// GameReversi.cpp: CGameReversi NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GameReversi.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CGameReversi::CGameReversi()
: CReversi()
{
	// ftHg---------------------------
	m_nFirstPlayer	= ePlayer_MAN;		//! ŨvC[
	m_nLastPlayer	= ePlayer_COM1;		//! ŨvC[
	m_bGuide		= TRUE;		//!	KCh\̃tO
	//--------------------------------------

	// Ֆʂ̕]l
	int a,b;
	m_nBoardValue[0][0] =  5; m_nBoardValue[1][1] = -5; m_nBoardValue[2][2] = 2; m_nBoardValue[3][3] = 0;
	m_nBoardValue[1][0] = -4; m_nBoardValue[2][0] =  4; m_nBoardValue[3][0] = 3;
	m_nBoardValue[2][1] = -2; m_nBoardValue[3][1] = -1; m_nBoardValue[3][2] = 1;

	for ( b=0; b<4; b++ ) {
		for ( a=0; a<4; a++ ) {
			if ( a == b ) {
				m_nBoardValue[7-a][  b] = 
				m_nBoardValue[  a][7-b] = 
				m_nBoardValue[7-a][7-b] = m_nBoardValue[a][b];
			}
			else if ( a > b ) {
				m_nBoardValue[  b][  a] = 
				m_nBoardValue[7-a][  b] = 
				m_nBoardValue[7-b][  a] = 
				m_nBoardValue[  a][7-b] = 
				m_nBoardValue[  b][7-a] = 
				m_nBoardValue[7-b][7-a] = 
				m_nBoardValue[7-a][7-b] = m_nBoardValue[a][b];
			}
		}
	}

	DataInitialize();
}

CGameReversi::~CGameReversi()
{

}

//protected:
// f[^̊֐
/*virtual*/ void CGameReversi::DataInitialize()
{
	CReversi::DataInitialize();
	m_nProcessPos	= 0;		//! ̎萔
	m_nCurrentOrder	= eOrder_FIRST;	//! ݂̎菇
}

// ̊G̍XV
void CGameReversi::RefreshPieceDc()
{
	/*
	CRect CircleRect;
	// ~GAݒ
	left   = int(m_nMassWidth/10);
	top    = int(m_nMassHeight/10);
	right  = int(m_nMassWidth - m_nMassWidth/10);
	bottom = int(m_nMassHeight - m_nMassHeight/10);
	CircleRect.SetRect(left, top, right, bottom);

	CDC dc, CBitmap bmp;
	dc.CreateCompatibleDC(NULL);
	bmp.CreateCompatibleBitmap(NULL, CircleRect.Width(), CircleRect.Height());

	CBitmap* pOld = dc.SelectObject(&bmp);

	dc.FillSolidRect(&CircleRect, m_BgColor);

	CPen pen(PS_SOLID,1,PenColor);
	CBrush brush(BrushColor);
	CPen* oldPen=dc.SelectObject(&pen);
	CBrush* oldBrush=dc.SelectObject(&brush);

	// `悷
	dc.Ellipse(&CircleRect);

	// yƃuV߂
	dc.SelectObject(oldPen);
	dc.SelectObject(oldBrush);

	m_FirstPieceDc.DeleteDC(); 
	m_FirstPieceBmp.DeleteObject();
	m_LastPieceDc.DeleteDC();
	m_LastPieceBmp.DeleteObject();

	m_FirstPieceDc.CreateCompatibleDC(NULL);

	pDC->StretchBlt(lpRect->left, lpRect->top, lpRect->Width(), lpRect->Height(), &dc,
		0, 0, CircleRect.Width(), CircleRect.Height(), SRCCOPY );*/
}


//protected:
// lԂ
BOOL CGameReversi::PutPiece(int nOrder, int x, int y)
{
	BOOL bRet = CReversi::PutPiece( m_nCurrentOrder, x, y );

	// u玟̏
	if ( bRet ) { PutPieceAfter(); }
	return bRet;
}

// Rs[^
BOOL CGameReversi::PutPieceAuto()
{
	int nLevel = GetPlayer( m_nCurrentOrder );

	if ( nLevel > 0 ) {
		//v\
		CWaitCursor wait;

		// Rs[^̃xAǂ݂čœK𓾂
		// 낻}ṼXybNĂ̂
		// +1ǂ݂Ă݂ 2006.12
		int x=10, y=10;
		ThinkNext( nLevel+1, m_nCurrentOrder, &x, &y);

		//v
		wait.Restore();

		//œKł
		return PutPiece( m_nCurrentOrder, x, y );
	}

	return FALSE;
}

// ł̏ōs
void CGameReversi::PutPieceAfter()
{
	int nNextOrder = !m_nCurrentOrder;

	// Ƒ肪uƂ\
	BOOL bCurrentPut = IsCanPut(m_nCurrentOrder);
	BOOL bNextPut = IsCanPut(nNextOrder);

	// ɒuꏊ
	if ( bNextPut ) {
		// Uh`FW
		m_nCurrentOrder = nNextOrder;
	}
}
	
//protected:
// Ֆʕ`
void CGameReversi::DrawBoard(CDC* pDC)
{
	// {NX̕`
	CReversi::DrawBoard(pDC);
}

// KCh`
void CGameReversi::DrawGuide(CDC* pDC, int nOrder)
{
	int x,y;
	CRect rc;

	int nBasex = m_BoardRect.left + m_PaddingRect.left;
	int nBasey = m_BoardRect.top + m_PaddingRect.top;

	// }XS`FbN
	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			if ( ReversePiece(x, y, nOrder, TRUE) > 0 ) {
				// ~GAݒ
				rc.left   = (int)(nBasex + x*m_nMassWidth + m_nMassWidth/2.5);
				rc.top    = (int)(nBasey + y*m_nMassHeight + m_nMassHeight/2.5);
				rc.right  = (int)(nBasex + (x+1)*m_nMassWidth - m_nMassWidth/2.5);
				rc.bottom = (int)(nBasey + (y+1)*m_nMassHeight - m_nMassHeight/2.5);

				// ̐Fɂ~`
				if ( eOrder_FIRST == nOrder ) {
					PaintCircle(pDC, &rc, m_FirstPieceColor, m_FirstPieceColor );
				} else {
					PaintCircle(pDC, &rc, m_LastPieceColor, m_LastPieceColor );
				}
			}
		}
	}
}

// ~`悷    
void CGameReversi::PaintCircle(CDC* pDC, CRect* lpRect, COLORREF pen, COLORREF brush)
{
	CReversi::PaintCircle(pDC, lpRect, pen, brush);
}

//protected:
// ǂݏ
void CGameReversi::ThinkNext(int nNextDepth, int nOrder, int* x, int* y)
{
	int i,j;
	int nCount = 0;
	int nBestCount = 0;
	int nPos = 0;
	int nPe = -10000;
	int nChildPe;
	int nOtherOrder = !nOrder;

	// u}X̐𐔂		
	for ( j=0; j<8; j++ ) {
		for ( i=0; i<8; i++ ) {
			if ( ReversePiece(i, j, nOrder, TRUE) > 0 ) nCount++;
		}
	}

	//uꏊȂȂI
	if ( !nCount ) return;

	// ̎胊Xgpm
	int (*pNextList)[3] = new int[nCount][3];

	// ՖʋLpm
	//int (*nTempBoard)[8] = new int[8][8];
	int nTempBoard[8][8];

	// ̏ԂRs[
	::memcpy( nTempBoard, m_nBoard, 64*sizeof(int) );

	// uꏊSɉu
	for ( j=0; j<8; j++ ) {
		for ( i=0; i<8; i++ ) {
			if ( CReversi::PutPiece( nOrder, i, j ) ) {
			
				// qm[h̕]l𒲂ׂ
				nChildPe = m_nBoardValue[i][j] + 
					AlphaBeta( nNextDepth, nNextDepth-1, nOtherOrder, nPe, 10000 );

				// ̎胊Xgɉ
				pNextList[nPos][0] = nChildPe;
				pNextList[nPos][1] = i;
				pNextList[nPos][2] = j;
				nPos++;

				// ՖʕAiuĒׂ猳̏Ԃɂ߂j
				::memcpy( m_nBoard, nTempBoard, 64*sizeof(int) );

				// ő̕]lI
				if ( nPe < nChildPe) {
					nPe = nChildPe;
				}
			}
		}
	}

	// Să`FbN
	// ՖʋLp
	//delete [] nTempaBorad;

	// ŗǒlm[h̐vZ
	for (i=0; i<nCount; i++) {
		if ( pNextList[i][0] == nPe ) {
			nBestCount++;
		}
	}

	// ŗǎ胊Xgpm
	int (*pBestCount)[2] = new int[nBestCount][2];
		
	// ŗǎ胊Xg쐬
	nPos = 0;
	for( i=0; i<nCount; i++ ) {
		if ( pNextList[i][0] == nPe ) {
			pBestCount[nPos][0] = pNextList[i][1];
			pBestCount[nPos][1] = pNextList[i][2];
			nPos++;
		}
	}

	// ŗǎ肪ꍇ
	// ̒烉_ɑI
	nPos = rand()%nBestCount;
	*x = pBestCount[nPos][0];
	*y = pBestCount[nPos][1];

	// 
	delete [] pNextList;
	delete [] pBestCount;
}

// -T
int CGameReversi::AlphaBeta( int nDepth, int nCurrentDepth, int nOrder, int nAlpha, int nBeta )
{
	int nPe;	//]l
	int nOtherOrder = !nOrder;
	
	// Ƒ肪uƂ\
	BOOL bCanOrderPut = IsCanPut(nOrder);
	BOOL bCanOtherPut = IsCanPut(nOtherOrder);

	// ŉwQ[Ĩm[hȂ獡̏Ԃ̕]lvZĕԂ
	if ( nCurrentDepth == 0 || !( bCanOrderPut || bCanOtherPut ) ) {
		return GetPieceCount( m_nCurrentOrder ); // GetValue( m_nCurrentnOrder );
	}
	// m[hpXȂ炻̂܂܎q֍sAq̕]lԂ
	else if ( !bCanOrderPut ) {
		if( (nDepth - nCurrentDepth)%2 == 0 ) {
			return AlphaBeta( nDepth, nCurrentDepth-1, nOtherOrder, 10000, nBeta );
		} else {
			return AlphaBeta( nDepth, nCurrentDepth-1, nOtherOrder, nAlpha, -10000 );
		}
	}
	else {
		int x,y;				// forp
		int nChildPe;			// qm[h̕]l
		int nTempBoard[8][8];	// ՖʋLp

		// ̏ԂRs[
		::memcpy( nTempBoard, m_nBoard, 64*sizeof(int) );
	
		// MAX xȂ
		if ( (nDepth-nCurrentDepth)%2 == 0 ) {
			nPe = -10000;
			
			// uꏊSɉu
			for ( y=0; y<8; y++ ) {
				for ( x=0; x<8; x++ ) {
					if ( CReversi::PutPiece( nOrder, x, y ) ) {
				
						// qm[h̕]l𒲂ׂ
						nChildPe = AlphaBeta( nDepth, nCurrentDepth-1, nOtherOrder, nPe, nBeta );

						// ՖʕAiuĒׂ炷߂j
						::memcpy( m_nBoard, nTempBoard, 64*sizeof(int) );
	
						// ő̕]lI
						if ( nPe < nChildPe ) {
							
							nPe = nChildPe;
							
							// beta傫炻őł
							if ( nPe > nBeta ) {
								// ]lԂ
								return nPe;
							}
						}
					}
				}
			}
		}
		// MINxȂ
		else {
			nPe = +10000;

			// uꏊSĂɉu
			for ( y=0; y<8; y++ ) {
				for ( x=0; x<8; x++ ) {
					if ( CReversi::PutPiece( nOrder, x, y ) ) {
	
						// qm[h̕]l𒲂ׂ
						nChildPe = AlphaBeta(nDepth, nCurrentDepth-1, nOtherOrder, nAlpha, nPe);
	
						// ՖʕAiuĒׂ炷߂j
						::memcpy( m_nBoard, nTempBoard, 64*sizeof(int) );
	
						// ŏ̕]lI
						if ( nPe > nChildPe ) {
							nPe = nChildPe;
							// nAlpha菬炻őł
							if ( nPe < nAlpha ) {
								// ]lԂ
								return nPe;
							}
						}
					}
				}
			}
		}
		// ]lԂ
		return nPe;
	}
}

// ]lvZ	
int CGameReversi::GetValue(int nOrder)
{
	int x, y;
	int nValue = 0;
	int nOtherOrder = !nOrder;

	// uĂ̕]l̘a߂
	for ( y=0; y<8; y++ ) {
		for ( x=0; x<8; x++ ) {
			if ( m_nBoard[x][y] == nOrder ) {
				nValue += m_nBoardValue[x][y];
			} else if ( m_nBoard[x][y] == nOtherOrder ) {
				nValue -= m_nBoardValue[x][y];
			}
		}
	}

	return nValue;
}

//public:
// Q[Jn
void CGameReversi::StartGame()
{
	//f[^
	DataInitialize();
}

// Q[Iǂ𔻒肷
BOOL CGameReversi::IsGameSet()
{
	return (!IsCanPut(eOrder_FIRST) && !IsCanPut(eOrder_LAST)) ? TRUE : FALSE;
}

// Rs[^Ɏ̎ł܂
BOOL CGameReversi::NextByComputer()
{
	if ( GetPlayer(m_nCurrentOrder) != ePlayer_MAN ) {
		return PutPieceAuto();
	}
	return FALSE;
}

// NbNŋu
BOOL CGameReversi::MouseClick(const CPoint& point)
{
	// lԂ̔Ԃ
	if ( GetPlayer(m_nCurrentOrder) == ePlayer_MAN ) {

		int nBasex = m_BoardRect.left + m_PaddingRect.left;
		int nBasey = m_BoardRect.top + m_PaddingRect.top;

		int x = (point.x - nBasex) / m_nMassWidth;	// ̃}X
		int y = (point.y - nBasey) / m_nMassHeight;	// c̃}X
		
		// }ẌʒuΒu
		if ( (x>=0 && x<8)  &&  (y>=0 && y<8) ) {
			return PutPiece( m_nCurrentOrder, x, y );
		}
	}
	return FALSE;
}

// Ֆʂ̕`
void CGameReversi::Draw(CDC* pDC)
{
	// Օ`
	DrawBoard(pDC);
	// `
	DrawPiece(pDC);
	// KCh\
	if ( GetPlayer(m_nCurrentOrder) == ePlayer_MAN && m_bGuide ) {
		DrawGuide(pDC, m_nCurrentOrder);
	}
}

// ʃf[^ݒ
void CGameReversi::SetBoardRect(CRect* lpRect)
{
	CReversi::SetBoardRect(lpRect);
	RefreshPieceDc();
}