// ReversiGameDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ReversiGame.h"
#include "ReversiGameDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReversiGameDlg _CAO

CReversiGameDlg::CReversiGameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReversiGameDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReversiGameDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pIniFile = NULL;
}

CReversiGameDlg::~CReversiGameDlg()
{
	if ( m_pIniFile ) {
		delete m_pIniFile;
	}
}

void CReversiGameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReversiGameDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReversiGameDlg, CDialog)
	//{{AFX_MSG_MAP(CReversiGameDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_NCPAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_TIMER()
	ON_COMMAND(ID_GAME_START, OnGameStart)
	ON_COMMAND(ID_GAME_OPTION, OnGameOption)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReversiGameDlg bZ[W nh

BOOL CReversiGameDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	m_pIniFile = new CXProfile();
	m_pIniFile->CreateIniFile();

	m_dlgOption.m_nFirstPlayer = m_pIniFile->GetProfileInt(_T("Option"),_T("FirstPlayer"),CGameReversi::ePlayer_MAN );
	m_dlgOption.m_nLastPlayer = m_pIniFile->GetProfileInt(_T("Option"),_T("LastPlayer"),CGameReversi::ePlayer_COM1 );
	m_dlgOption.m_bIsGuideView = m_pIniFile->GetProfileInt(_T("Option"),_T("Guide"),TRUE );

	int cx = m_pIniFile->GetProfileInt(_T("Window"),_T("cx"), 348 );
	int cy = m_pIniFile->GetProfileInt(_T("Window"),_T("cy"), 352 );
	SetWindowPos( &CWnd::wndTop, 0, 0, cx, cy, SWP_NOZORDER|SWP_NOMOVE );

	m_Reversi.SetFirstPieceColor(RGB(255,255,255));
	m_Reversi.SetLastPieceColor(RGB(30,30,30));
	m_Reversi.SetBorderColor(RGB(30,30,30));

	m_Reversi.SetPlayer( m_dlgOption.m_nFirstPlayer, m_dlgOption.m_nLastPlayer );
	m_Reversi.SetGuideView(m_dlgOption.m_bIsGuideView);

	// ^C}N
	SetTimer(0,100,NULL);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CReversiGameDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CReversiGameDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		if ( CDC* pDC = this->GetDC() ) {

			// _uobt@O
			CRect rect;
			GetClientRect(&rect);
			CDC dc;
			CBitmap bmp;
			dc.CreateCompatibleDC(pDC);
			bmp.CreateCompatibleBitmap(pDC, rect.Width(), rect.Height());
			CBitmap* pOld = dc.SelectObject(&bmp);
			m_Reversi.Draw(&dc);
			pDC->BitBlt(0,0,rect.Width(),rect.Height(),&dc,0,0,SRCCOPY);
			ReleaseDC(pDC);
			dc.SelectObject(pOld);
		}
	}
}

void CReversiGameDlg::OnNcPaint() 
{
	CDialog::OnNcPaint();

	if ( CDC* pDC = GetWindowDC() ) {
		CRect rect;
		GetWindowRect(&rect);
		rect.OffsetRect(-rect.left, -rect.top);
		rect.DeflateRect(4,4);
		pDC->ExcludeClipRect(&rect);
		rect.InflateRect(4,4);
		pDC->FillSolidRect(&rect,RGB(0,0,0));
		ReleaseDC(pDC);
	}

}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CReversiGameDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReversiGameDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if ( cx >0 && cy > 0 ) {
		CRect rc;
		this->GetClientRect(&rc);
		m_Reversi.SetBoardRect(&rc);
		this->Invalidate(FALSE);
	}
	
}

void CReversiGameDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	GamePlaying(point);
	CDialog::OnLButtonDown(nFlags, point);
}

void CReversiGameDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	GamePlaying(point);
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CReversiGameDlg::GamePlaying(const CPoint& point)
{
	if ( m_Reversi.MouseClick( point ) ) {
		Invalidate(FALSE);
		JudgeGame();
	}
}

void CReversiGameDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if ( nIDEvent == 0 ) {
		if ( m_Reversi.GetPlayer(m_Reversi.GetCurrentOrder()) != CGameReversi::ePlayer_MAN ) {
			if ( m_Reversi.NextByComputer() ) {
				Invalidate(FALSE);
				JudgeGame();
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CReversiGameDlg::JudgeGame()
{
	if ( m_Reversi.IsGameSet() ) {
		
		int nFirst = m_Reversi.GetPieceCount(CGameReversi::eOrder_FIRST);
		int nLast = m_Reversi.GetPieceCount(CGameReversi::eOrder_LAST);

		CString strResult;
		// 
		if ( nFirst == nLast ) {
			strResult.LoadString(IDS_RESULT_DRAW);
		// 菟
		} else if ( nFirst > nLast ) {
			strResult.LoadString(IDS_RESULT_WIN_FIRST_PLAYER);
		// 菟
		} else {
			strResult.LoadString(IDS_RESULT_WIN_LAST_PLAYER);
		}
		CString str,strTemp;
		strTemp.LoadString(IDS_GAMESET_STRING);
		str.Format( strTemp, nFirst, nLast, strResult );
		CString strCaption;
		strCaption.LoadString(IDS_GAMESET_TITLE);
		if ( IDYES == MessageBox(str, strCaption, MB_YESNO|MB_ICONINFORMATION) ) {
			m_Reversi.StartGame();
			Invalidate(FALSE);
		}
	}
}

void CReversiGameDlg::OnGameStart() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_Reversi.StartGame();
	Invalidate(FALSE);
}

void CReversiGameDlg::OnGameOption() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	KillTimer(0);
	if ( IDOK == m_dlgOption.DoModal() ) {
		m_Reversi.SetPlayer(m_dlgOption.m_nFirstPlayer,m_dlgOption.m_nLastPlayer);
		m_Reversi.SetGuideView(m_dlgOption.m_bIsGuideView);
		Invalidate(FALSE);
	}

	SetTimer(0,100,NULL);
}

BOOL CReversiGameDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	return CDialog::PreTranslateMessage(pMsg);
}

void CReversiGameDlg::OnDestroy() 
{
	CRect rect;
	GetWindowRect(&rect);

	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_pIniFile->WriteProfileInt(_T("Option"), _T("FirstPlayer"), m_dlgOption.m_nFirstPlayer );
	m_pIniFile->WriteProfileInt(_T("Option"), _T("LastPlayer"), m_dlgOption.m_nLastPlayer );
	m_pIniFile->WriteProfileInt(_T("Option"), _T("Guide"), m_dlgOption.m_bIsGuideView );

	m_pIniFile->WriteProfileInt(_T("Window"), _T("cx"), rect.Width() );
	m_pIniFile->WriteProfileInt(_T("Window"), _T("cy"), rect.Height() );
	
}
