// ReversiGameDlg.h : wb_[ t@C
//

#if !defined(AFX_REVERSIGAMEDLG_H__D3C0E7D8_D6D1_4658_9376_0C204F9EAD6D__INCLUDED_)
#define AFX_REVERSIGAMEDLG_H__D3C0E7D8_D6D1_4658_9376_0C204F9EAD6D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GameReversi.h"
#include "DlgOption.h"
#include "XProfile.h"

/////////////////////////////////////////////////////////////////////////////
// CReversiGameDlg _CAO

class CReversiGameDlg : public CDialog
{
// \z
public:
	CReversiGameDlg(CWnd* pParent = NULL);	// W̃RXgN^
	virtual ~CReversiGameDlg();

// _CAO f[^
	//{{AFX_DATA(CReversiGameDlg)
	enum { IDD = IDD_REVERSIGAME_DIALOG };
		// : ̈ʒu ClassWizard ɂăf[^ oǉ܂B
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CReversiGameDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;
	CDlgOption m_dlgOption;
	CGameReversi m_Reversi;
	CXProfile* m_pIniFile;

	void GamePlaying(const CPoint& point);
	void JudgeGame();

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CReversiGameDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnNcPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGameStart();
	afx_msg void OnGameOption();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_REVERSIGAMEDLG_H__D3C0E7D8_D6D1_4658_9376_0C204F9EAD6D__INCLUDED_)
