#include "StdAfx.h"
#include ".\xprofile.h"

CXProfile::CXProfile(void)
{
}

CXProfile::~CXProfile(void)
{
}

BOOL CXProfile::CreateIniFile( const CString& strPathName )
{
	if ( strPathName.IsEmpty() ) 
	{
		TCHAR szBuf[ _MAX_PATH ];
		TCHAR szDrive[ _MAX_DRIVE ];
		TCHAR szDir[ _MAX_DIR ];
		TCHAR szFileName[ _MAX_FNAME ];
		WIN32_FIND_DATA wfd;
		HANDLE  hFindFile;

		// ȃAṽpXiׂđ啶j
		::GetModuleFileName( NULL, szBuf, _MAX_PATH );

		// t@C̏ڍ׏𓾂
		hFindFile = ::FindFirstFile( szBuf, &wfd );
		
		if ( hFindFile != INVALID_HANDLE_VALUE ) {
			// pX𕪉čē
			// (WIN32_FIND_DATAgđ啶ʂt@C szBuf ɂ)
			_tsplitpath( szBuf, szDrive, szDir, NULL, NULL );
			_tmakepath( szBuf, szDrive, szDir, wfd.cFileName, NULL );
			::FindClose( hFindFile );
		}
		
		// pX𕪉čē
		// (gq ini ɂ)
		_tsplitpath( szBuf, szDrive, szDir, szFileName, NULL );
		_tmakepath( szBuf, szDrive, szDir, szFileName, _T("ini") );
		
		m_strPathName = szBuf;
		
	} else {
		m_strPathName = strPathName;
	}

	return TRUE;
}

UINT CXProfile::GetProfileInt( LPCTSTR lpszSection, LPCTSTR lpszEntry, int nDefault )
{
	return ::GetPrivateProfileInt( lpszSection, lpszEntry, nDefault, this->m_strPathName );
}

BOOL CXProfile::WriteProfileInt( LPCTSTR lpszSection, LPCTSTR lpszEntry, int nValue )
{
	CString strValue; strValue.Format( _T("%d"), nValue );
	return ::WritePrivateProfileString( lpszSection, lpszEntry, strValue, this->m_strPathName );
}

CString CXProfile::GetProfileString( LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault )
{
	DWORD dwSize = _MAX_PATH; // TBD
	TCHAR szValue[_MAX_PATH] = {0};
	::GetPrivateProfileString( lpszSection, lpszEntry, lpszDefault, szValue, dwSize, this->m_strPathName );
	return CString(szValue);
}

BOOL CXProfile::WriteProfileString( LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue )
{
	return ::WritePrivateProfileString( lpszSection, lpszEntry, lpszValue, this->m_strPathName );
}