#pragma once

class CReversi  
{
public:
	//! 菇isUj
	enum {
		eOrder_FIRST=0, 
		eOrder_LAST=1, 
		eOrder_EMPTY=-1
	};
protected:
	int			m_nBoard[8][8];			//! Ֆʂ̋̐F
	int			m_nMassWidth;			//! ڂ̕
	int			m_nMassHeight;			//! ڂ̕
	CRect		m_BoardRect;			//! EChȆ傫
	CRect		m_PaddingRect;			//! 
	COLORREF	m_FirstPieceColor;		//! s̋F
	COLORREF	m_LastPieceColor;		//! ŰF
	COLORREF	m_BorderColor;			//! g̐F
	COLORREF	m_BgColor;				//! wi̐F
	COLORREF	m_TextColor;			//! ̐F

public:
	CReversi();
	virtual ~CReversi();

protected:
	// ~`悷    
	virtual void PaintCircle(CDC* pDC,CRect* lpRect,COLORREF pen,COLORREF brush);

	// 𗠕Ԃ֐
	virtual int ReversePiece(int x,int y,int nOrder,BOOL bCheckOnly);

	// w肳ꂽʒuw肳ꂽFɂ
	virtual void SetPieceColor(int x, int y, int nOrder);

public:
	// f[^̊֐
	virtual void DataInitialize();

	// Օ`
	virtual void DrawBoard(CDC* pDC);

	// ̕`̊֐
	virtual void DrawPiece(CDC* pDC);
	
// 
public:
	// w肳ꂽF̋uꏊ邩
	virtual BOOL IsCanPut(int nOrder);

	// u
	virtual BOOL PutPiece(int nOrder, int x, int y);

	// ŋu
	virtual BOOL PutPieceAuto(int nLevel, int nOrder);

	// w肳ꂽF̋̐Ԃ֐
	virtual int GetPieceCount(int nOrder);

	// w肳ꂽʒűUU擾
	virtual int GetOrderOnPiece(int x,int y);

public:
	// ʃf[^ݒ
	virtual void SetBoardRect(CRect* lpRect);

// eF̐ݒE擾
public:
	// J[ݒ  
	virtual void SetColor(COLORREF bg, COLORREF border,COLORREF first,COLORREF last,COLORREF text) {
		m_FirstPieceColor	= first;	//! s̋F
		m_LastPieceColor	= last;		//! ŰF
		m_BorderColor		= border;	//! g̐F
		m_BgColor			= bg;		//! wi̐F
		m_TextColor			= text;		//! ̐F
	}

	// 菇̋F擾
	virtual COLORREF GetOrderPieceColor(int nOrder){
		if ( nOrder ) return m_LastPieceColor;
		else return m_FirstPieceColor;
	}

	// ŰFݒ肷
	virtual COLORREF SetFirstPieceColor(COLORREF cr) {
		COLORREF old = m_FirstPieceColor;
		m_FirstPieceColor = cr;
		return old;
	}
	// ŰF擾
	virtual COLORREF GetFirstPieceColor() { return m_FirstPieceColor; }

	// ŰFݒ肷
	virtual COLORREF SetLastPieceColor(COLORREF cr) {
		COLORREF old = m_LastPieceColor;
		m_LastPieceColor = cr;
		return old;
	}

	// ŰF擾
	virtual COLORREF GetLastPieceColor() { return m_LastPieceColor; }

	// g̐Fݒ肷
	virtual COLORREF SetBorderColor(COLORREF cr) {
		COLORREF old = m_BorderColor;
		m_BorderColor = cr;
		return old;
	}

	// g̐F擾
	virtual COLORREF GetBorderColor() { return m_BorderColor; }

	// wiFݒ肷
	virtual COLORREF SetBgColor(COLORREF cr) {
		COLORREF old = m_BgColor;
		m_BgColor = cr;
		return old;
	}

	// wiF擾
	virtual COLORREF GetBgColor() { return m_BgColor; }

	// Fݒ肷
	virtual COLORREF SetTextColor(COLORREF cr) {
		COLORREF old = m_TextColor;
		m_TextColor = cr;
		return old;
	}

	// F擾
	virtual COLORREF GetTextColor() { return m_TextColor; }
};

